#!/usr/bin/perl
use constant PORT=>10555;
my($act,$ip,$id,$flag)=@ARGV;
use LWP::UserAgent;
my $ua=LWP::UserAgent->new;
$ua->agent("MyApp/0.1");
my @design=();
my @alphabet=('0'..'9','A'..'Z','a'..'z','+','-','\\','/','=','_');
my %automat=(
'/'=>sub{my($c,$p,$i)=@_;if(!$p){if($c){$p=1;};}else{$p=0;};('/',$c,$p,$i);},
'\\'=>sub{my($c,$p,$i)=@_;if(!$p){if(!$c){$p=1;};}else{$p=0;};('\\',$c,$p,$i);},
'|'=>sub{my($c,$p,$i)=@_;if(!$p){$i=-1;};(' ',$c,$p,$i);},
'^'=>sub{my($c,$p,$i)=@_;if(!$p){$c='0';my $o=0;for($li=0;$li<@alphabet;$li++){if($alphabet[$li] eq $c){$c=$li;$o=1;};};if(!$o){$c=0;}};('^',$c,$p,$i);},
'+'=>sub{my($c,$p,$i)=@_;if(!$p){$c++;};('+',$c,$p,$i);},
'-'=>sub{my($c,$p,$i)=@_;if(!$p){$c--;};('-',$c,$p,$i);},
'_'=>sub{my($c,$p,$i)=@_;if(!$p){$c>>=1;};('_',$c,$p,$i);},
':'=>sub{my($c,$p,$i)=@_;if(!$p){$c*=10;};(':',$c,$p,$i);},
'='=>sub{my($c,$p,$i)=@_;if(!$p){$c=($c?1:0);};('=',$c,$p,$i);},
'['=>sub{my($c,$p,$i)=@_;if(!$p){$c<<=3;};('[',$c,$p,$i);},
']'=>sub{my($c,$p,$i)=@_;if(!$p){$c>>=3;};(']',$c,$p,$i);},
'*'=>sub{my($c,$p,$i)=@_;if(!$p){$c+=$design[-1]||0;};('*',$c,$p,$i);},
'~'=>sub{my($c,$p,$i)=@_;if(!$p){$c=serverrand($c);};('~',$c,$p,$i);}
);

my %checked=();

#####################################HOUSE -> DESIGN
sub serverrand{(((shift)>>2)+1)*4;}
sub apparatus
{
	my($a,@lin)=@_;
	my %aut=%$a;
	my $c=0;
	my $p=0;
	my $pi=0;
	for(my $ci=0;$ci<@lin;$ci++)
	{
		if($aut{$lin[$ci]})
		{
			print "(c=".$lin[$ci]."(ip=$ci,if=$p))->" if($checked{'t'} && !$checked{'d'});
			$pi=$ci;
			($lin[$pi],$c,$p,$ci)=$aut{$lin[$pi]}($c,$p,$pi);
			print "v=$c(ip=$ci,if=$p)->" if($checked{'t'} && !$checked{'d'});
			$c+=0x44;
			$c%=0x44;
		}
	}
	$c;
}
sub housetodesign
{
	my @house=@_;
	my $result;
	$result=pop @house if($checked{'t'});
	my $house="@house";
	my $design='';
	@design=();
	my @lines=@house;
	print scalar(@lines)." lines and letters in result\n" if($checked{'t'});
	for(@lines)
	{
		my @line=split(//);
		my $c=0;
		print "$_: v=$c(ip=0,if=0)->" if($checked{'t'});
		$c=apparatus(\%automat,@line);
		print "v=$c = ".$alphabet[$c]."\n\n" if($checked{'t'});
		push @design,$c;
	}
	for(@design){$design.=$alphabet[$_];}
	#print $design.($checked{'t'}?"\n".$result."\n".($design eq $result?'TRUE':'FALSE'):'');
	return ($design ne $result) if($checked{'t'});
	return $design;
}

if(!$ip)
{
	print "No IP defined";
	exit(10);
}

my $req=0;
if($act eq 'put')
{
	if(!$flag)
	{
		print "No Flag defined";
		exit(10);
	}
	$req=HTTP::Request->new(POST=>"http://$ip:".PORT."/Design");
	$req->content_type('application/x-www-form-urlencoded');
	$req->content('design='.$flag);
}
if($act eq 'get')
{
	if(!$id)
	{
		print "No Flag ID defined";
		exit(10);
	}
	$req=HTTP::Request->new(POST=>"http://$ip:".PORT."/Build");
	$req->content_type('application/x-www-form-urlencoded');
	$req->content('designid='.$id);
}
if($act eq 'check')
{
	$req=HTTP::Request->new(GET=>"http://$ip:".PORT."/");
}

if(!$req)
{
	print "No Command defined";
	exit(10);
}

my $res = $ua->request($req);
if ($res->is_success) {
	if($act eq 'put')
	{
		$res->content=~/<td>[^<]*<br\/?>([^<]*)<\/td>/s;
		my $h=$1;
		$h=~s/^\s+|\s+$//sg;
		if(!$h || !length($h))
		{
			print "No Flag ID found";
			exit(3);
		}
		print $h;
		exit(1);
	}
	if($act eq 'get')
	{
		$res->content=~/<pre>(.*?)<\/pre>/s;
		my $h=$1;
		$h=~s/^\s+|\s+$//sg;
		if(!$h || !length($h))
		{
			print "No Flag found";
			exit(2);
		}
		if(!$flag)
		{
			print "No Flag defined";
			exit(10);
		}
#		$h=~s/\s+//g;			#stubb
#		if($flag eq $h)			#stubbb
		if($flag eq housetodesign(split("\n",$h)))
		{
			print "Ol Korrekt";
			exit(1);
		}else{
			print STDERR $flag.' ne '.housetodesign(split("\n",$h))."\n";
			print "Incorrect Flag";
			exit(2);
		}
	}
	if($act eq 'check')
	{
		if($res->content=~/\<object\s+title\=\"[^\"]*\"\s+width\=\"\d+\"\s+height\=\"\d+\"\s+classid\=\"[^\"]*\"\s+codebase\=\"[^\"]*\"\>\s*<param\s+name\=\"movie\"\s+value\=\"http\:\/\/$ip\:316\/\"\>\s*\<param\s+name=\"allowScriptAccess\"\s+value=\"always\"\>\s*\<param\s+name\=\"wmode\"\s+value\=\"transparent\"\>\s*\<embed\s+title\=\"[^\"]*\"\s+src\=\"http\:\/\/$ip\:316\/\"\s+wmode\=\"transparent\"\s+pluginspage\=\"http\:\/\/www.macromedia.com\/go\/getflashplayer\"\s+type\=\"application\/x-shockwave-flash\"\s+width\=\"\d+\"\s+height\=\"\d+\"\s+allowScriptAccess\=\"always\"\>\<\/embed\>\s*\<\/object\>/si)
		{
			print "Ol Korrekt";
			exit(1);
		}else{
			print "No Banner found";
			exit(3);
		}
	}
}else{
	if($res->status_line)
	{
		my ($code,$message)=($res->status_line=~/(\d+)\s+(.*)/);
		if($code >= 500)
		{
			print $res->status_line;
			exit(4);
		}else{
			print $res->status_line;
			exit(3);
		}
	}else{
		print "Connection refused";
		exit(4);
	}
}
print "Extremely strange behavior";
exit(10);