<?xml version="1.0" encoding="utf-8"?>
<x:stylesheet version="1.0" xmlns:x="http://www.w3.org/1999/XSL/Transform"
	xmlns='http://www.w3.org/1999/xhtml'>
	
	<x:preserve-space elements='code'/>
	<x:include href='common.xsl'/>
	
	<x:template match='service'>
		<html>
			<head>
				<title>
					<x:value-of select="document('config.xml')/project/@name"/> /
						Service «<x:value-of select="/service/head/title"/>»
				</title>
				<style>@import "doc.css";</style>
			</head>
			<body>
				<table width='800' align='center'><tr>
					<td class='left'>
						<a href="{document('config.xml')/project/@site}">
							<x:value-of select="document('config.xml')/project/@name"/>
						</a> / #<x:value-of select="head/id"/><br/><br/>
						Version: <x:value-of select="head/date/@version"/><br/>
						Date: <x:value-of select="head/date/@year"/>.<x:value-of
							select="head/date/@month"/>.<x:value-of
							select="head/date/@day"/>
					</td>
					<td class="right"><x:apply-templates select="/service/head/author"/></td>
				</tr>
				<tr><td colspan="2">
				<br/><div class="center">Service «<x:value-of select="/service/head/title"/>»</div><br/><br/>

				<div class='title'>Document Status</div><br/>
				<div class='indent p'>This document is a description of service «<x:value-of select='/service/head/title'/>».
					Distribution of this document is strictly limited until the time championship has passed.</div><br/><br/>
			
				<x:apply-templates select='description'/>
				<x:apply-templates select='requirements'/>
				<x:apply-templates select='abstract'/>
				<x:apply-templates select='network'/>
				<x:apply-templates select='legend'/>
				<x:apply-templates select='files'/>
				<x:apply-templates select='links'/>
				<x:apply-templates select='bugs'/>
				<x:apply-templates select='quests'/>
				<x:apply-templates select='checker'/>
				<x:apply-templates select='setup'/>
				
            </td></tr>
            </table>

			</body>
		</html>
	</x:template>
		
	<x:template match="author"><a href="mailto:{@email}" target="_blank"><x:value-of select="."/></a><br/></x:template>

	<x:template match='service/description'>
		<div class='title'>Breif Description</div><br/>
		<div class='indent p'><x:value-of select='.'/></div><br/><br/>
	</x:template>

	<x:template match='service/requirements'>
		<div class='title'>Prerequisites</div><br/>
		<div class='indent p'><x:apply-templates mode='ol'/></div><br/>
		<x:if test='@test'>
			<div class='title'>Checker:
				<a href='{concat(concat(../head/id,"_files/"),@test)}'><x:value-of select='@test'/></a>
			</div>
		</x:if>
		<br/>
	</x:template>

	<x:template match='service/abstract'>
		<div class='title'>General Description</div><br/>
		<div class='indent p'><x:apply-templates/></div><br/><br/>
	</x:template>

	<x:template match='service/network'>
		<div class='title'>Network</div><br/>
		<div class='indent p'><x:value-of select='.'/></div><br/><br/>
	</x:template>

	<x:template match='service/legend'>
		<div class='title'>Legend</div><br/>
		<div class='indent p'><x:value-of select='.'/></div><br/><br/>
	</x:template>

	<x:template match='service/files'>
		<div class='title'>List Of Service's Files</div><br/>
		<x:apply-templates/><br/>
	</x:template>

	<x:template match='service/files/file'>
		<div class='indent p'>
			<a href='{concat(concat(../../head/id,"_files/"),@src)}'><x:value-of select='@src'/></a>
			<x:if test='@dst'>
				(<x:value-of select='@dst'/> in the image)
			</x:if>
			<div class='indent p'><x:apply-templates/></div><br/>
		</div>
	</x:template>

	<x:template match='service/links'>
		<div class='title'>Interconnection With Other Services</div><br/>
		<div class='p'>
			<x:apply-templates/><br/>
		</div>
	</x:template>

	<x:template match='links/service'>
		<div class='indent p'><x:apply-templates/></div><br/>
	</x:template>

	<x:template match='service/bugs'>
		<div class='title'>Bug List</div><br/>
		<div class='indent p'><x:apply-templates/></div><br/>
	</x:template>

	<x:template match='bug'>
		<x:value-of select='@name'/><br/><br/>
		<div class='indent p'>
			<x:apply-templates select='description'/>
			<x:apply-templates select='attack'/>
			<x:apply-templates select='defence'/>
			<x:apply-templates select='advisory'/>
		</div>
	</x:template>

	<x:template match='bug/description'>
		<x:apply-templates/><br/><br/>
	</x:template>

	<x:template match='bug/attack'>
		<div class='title'>Exploits</div><br/>
		<div class='indent p'><x:apply-templates /></div><br/>
	</x:template>

	<x:template match='bug/defence'>
		<div class='title'>Defence</div><br/>
		<div class='indent p'><x:apply-templates/></div><br/>
	</x:template>

	<x:template match='bug/advisory'>
		<div class='title'>Sample Security Advisory</div><br/>
		<div class='indent p'><x:apply-templates/></div><br/>
	</x:template>

	<x:template match='service/quests'>
		<div class='title'>Quests</div><br/>
		<div class='indent p'><x:apply-templates/></div><br/>
	</x:template>

	<x:template match='quests/quest'>
		<x:value-of select='@name'/><br/><br/>
		<div class='indent p'>
			<x:apply-templates select='description'/>
			<x:apply-templates select='question'/>
			<x:apply-templates select='answer'/>
		</div>
	</x:template>
	
	<x:template match='quest/description'>
		<x:apply-templates /><br/>
	</x:template>

	<x:template match='quest/question'>
		<div>Question: <x:value-of select='.'/></div><br/>
	</x:template>

	<x:template match='quest/answer'>
		<div>Possible Answer: <x:value-of select='.'/></div><br/>
	</x:template>

	<x:template match='service/checker'>
		<div class='title'>Checker</div><br/>
		<div class='indent p'>
			<x:apply-templates select='description'/>
			<x:apply-templates select='files'/>
		</div>
	</x:template>

	<x:template match='checker/description'>
		<x:apply-templates /><br/>
	</x:template>
		
	<x:template match='checker/files'>
		<div class='title'>List Of Checker's Files</div><br/>
		<x:apply-templates/><br/>
	</x:template>

	<x:template match='checker/files/file'>
		<div class='indent p'>
			<a href='{concat(concat(/service/head/id,"_checker/"),@src)}'><x:value-of select='@src'/></a>
			<x:if test='@dst'>
				(<x:value-of select='@dst'/> in the image of the checking system)
			</x:if>
			<div class='indent p'><x:apply-templates/></div><br/>
		</div>
	</x:template>

	<x:template match='service/setup'>
		<div class='title'>Configuration Of Service</div><br/>
		<div class='indent p'>
			<x:choose>
				<x:when test='count(./action)!=0'>
					<x:apply-templates select='action'/>
				</x:when>
				<x:otherwise>
					No special configuration is necessary.
				</x:otherwise>
		</x:choose>
		</div>
	</x:template>

	<x:template match='service/setup/action'>
		<div><x:value-of select='1+count(preceding-sibling::action)'/>. <x:apply-templates /></div><br/>
	</x:template>

</x:stylesheet>

